# coding: utf-8

"""
    Lightly API

    Lightly.ai enables you to do self-supervised learning in an easy and intuitive way. The lightly.ai OpenAPI spec defines how one can interact with our REST API to unleash the full potential of lightly.ai  # noqa: E501

    OpenAPI spec version: 1.0.0
    Contact: support@lightly.ai
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from lightly.openapi_generated.swagger_client.configuration import Configuration


class JobsData(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'MongoObjectID',
        'job_id': 'str',
        'job_type': 'JobResultType',
        'dataset_id': 'MongoObjectID',
        'status': 'JobState',
        'finished_at': 'Timestamp',
        'created_at': 'Timestamp'
    }

    attribute_map = {
        'id': 'id',
        'job_id': 'jobId',
        'job_type': 'jobType',
        'dataset_id': 'datasetId',
        'status': 'status',
        'finished_at': 'finishedAt',
        'created_at': 'createdAt'
    }

    def __init__(self, id=None, job_id=None, job_type=None, dataset_id=None, status=None, finished_at=None, created_at=None, _configuration=None):  # noqa: E501
        """JobsData - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._id = None
        self._job_id = None
        self._job_type = None
        self._dataset_id = None
        self._status = None
        self._finished_at = None
        self._created_at = None
        self.discriminator = None

        self.id = id
        self.job_id = job_id
        self.job_type = job_type
        if dataset_id is not None:
            self.dataset_id = dataset_id
        self.status = status
        if finished_at is not None:
            self.finished_at = finished_at
        self.created_at = created_at

    @property
    def id(self):
        """Gets the id of this JobsData.  # noqa: E501


        :return: The id of this JobsData.  # noqa: E501
        :rtype: MongoObjectID
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this JobsData.


        :param id: The id of this JobsData.  # noqa: E501
        :type: MongoObjectID
        """
        if self._configuration.client_side_validation and id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def job_id(self):
        """Gets the job_id of this JobsData.  # noqa: E501


        :return: The job_id of this JobsData.  # noqa: E501
        :rtype: str
        """
        return self._job_id

    @job_id.setter
    def job_id(self, job_id):
        """Sets the job_id of this JobsData.


        :param job_id: The job_id of this JobsData.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and job_id is None:
            raise ValueError("Invalid value for `job_id`, must not be `None`")  # noqa: E501

        self._job_id = job_id

    @property
    def job_type(self):
        """Gets the job_type of this JobsData.  # noqa: E501


        :return: The job_type of this JobsData.  # noqa: E501
        :rtype: JobResultType
        """
        return self._job_type

    @job_type.setter
    def job_type(self, job_type):
        """Sets the job_type of this JobsData.


        :param job_type: The job_type of this JobsData.  # noqa: E501
        :type: JobResultType
        """
        if self._configuration.client_side_validation and job_type is None:
            raise ValueError("Invalid value for `job_type`, must not be `None`")  # noqa: E501

        self._job_type = job_type

    @property
    def dataset_id(self):
        """Gets the dataset_id of this JobsData.  # noqa: E501


        :return: The dataset_id of this JobsData.  # noqa: E501
        :rtype: MongoObjectID
        """
        return self._dataset_id

    @dataset_id.setter
    def dataset_id(self, dataset_id):
        """Sets the dataset_id of this JobsData.


        :param dataset_id: The dataset_id of this JobsData.  # noqa: E501
        :type: MongoObjectID
        """

        self._dataset_id = dataset_id

    @property
    def status(self):
        """Gets the status of this JobsData.  # noqa: E501


        :return: The status of this JobsData.  # noqa: E501
        :rtype: JobState
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this JobsData.


        :param status: The status of this JobsData.  # noqa: E501
        :type: JobState
        """
        if self._configuration.client_side_validation and status is None:
            raise ValueError("Invalid value for `status`, must not be `None`")  # noqa: E501

        self._status = status

    @property
    def finished_at(self):
        """Gets the finished_at of this JobsData.  # noqa: E501


        :return: The finished_at of this JobsData.  # noqa: E501
        :rtype: Timestamp
        """
        return self._finished_at

    @finished_at.setter
    def finished_at(self, finished_at):
        """Sets the finished_at of this JobsData.


        :param finished_at: The finished_at of this JobsData.  # noqa: E501
        :type: Timestamp
        """

        self._finished_at = finished_at

    @property
    def created_at(self):
        """Gets the created_at of this JobsData.  # noqa: E501


        :return: The created_at of this JobsData.  # noqa: E501
        :rtype: Timestamp
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this JobsData.


        :param created_at: The created_at of this JobsData.  # noqa: E501
        :type: Timestamp
        """
        if self._configuration.client_side_validation and created_at is None:
            raise ValueError("Invalid value for `created_at`, must not be `None`")  # noqa: E501

        self._created_at = created_at

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(JobsData, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, JobsData):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, JobsData):
            return True

        return self.to_dict() != other.to_dict()
